/*
 *  Copyright (C) 2003 2004
 *  Stefano Tonetta <stonetta@dit.unitn.it>
 *  Roberto Sebastiani <rseba@dit.unitn.it>
 *
*/
#ifndef AUTOMA_H
#define AUTOMA_H


#include "form.h"
#include "cover.h"





typedef struct GBA{
  int states_number;
  int initial_states;
  int prop_number;
  xstate** Q;
  char** R;
  char** F;
  int fair_number;
} GBA;

typedef struct BA{
  int states_number;
  int initial_states;
  int prop_number;
  xstate** Q;
  char** R;
  char* F;
} BA;


typedef struct transition {
  int source;
  int dest;
  form* label;
} transition;


typedef struct LBA{
  int states_number;
  int trans_number;
  int prop_number;
  transition** R;
  char* F;
} LBA;

GBA* new_GBA(form* f);
void print_GBA(GBA*,FILE*);
void print_GBAw(GBA*,FILE*);
void print_GBAn(GBA*,FILE*);
void print_GBAm(GBA*,FILE*);
void GBAtodot(GBA*);
BA* GBAtoBA(GBA*);

void print_BA(BA*,FILE*);
void print_BA2(BA*,FILE*);
void BAtodot(BA*);
LBA* BAtoLBA(BA*);

void print_LBA(LBA*,FILE*);
void print_LBAs(LBA*,FILE*);
void print_LBAs_l2s(LBA*,FILE*);
void print_LBA2(LBA*,FILE*);
void LBAtodot(LBA*);
LBA* prune(LBA*);



#endif
