/**CHeaderFile*****************************************************************

  FileName    [form.h]

  Package     [form]

  Author      [Stefano Tonetta]

  Copyright   [This file is part of MoDeLLa.
  Copyright (C) 2003-2006 by Stefano Tonetta and Roberto Sebastiani.]

  Version     [1.5.9]

******************************************************************************/

#ifndef FORM_H
#define FORM_H

#include <stdio.h>
#include "struct.h"

/*---------------------------------------------------------------------------*/
/* Type declarations                                                         */
/*---------------------------------------------------------------------------*/
/* the id is an array of char */
typedef char idtokentype;
typedef idtokentype * idtype;

/* the formula structure */
typedef struct form{
  idtype id;
  int type;
  int prop;
  struct form* left;
  struct form* right;
  list* c;
} form;

typedef struct fair{
  form* promise;
  form* fulfill;
} fair;

/*---------------------------------------------------------------------------*/
/* Variable declarations                                                     */
/*---------------------------------------------------------------------------*/
form *true,*false;
  
/*---------------------------------------------------------------------------*/
/* Function prototypes                                                       */
/*---------------------------------------------------------------------------*/
form* new_form(int,int,form*,form*);
void initialize_form();
void initialize_id();
void initialize_faircond();
int arequal(form*,form*);
form* DNF(form*);
form* expand(form*);
form* simplify(form*);
form* propagate(form*);
form* assign(int,int,form*);
form* Xfactoring(form*,int);
void print_form(form*);
void print_form_prefix(form*,FILE*);
void print_form_spin(form*,FILE*);
void print_form_nusmv(form*,FILE*);
int print_form_wring(form*,FILE*);

int idcmp(idtype,idtype);
int idcmpnot(idtype,idtype);
void idcpy(idtype,idtype);
int idimply(form*,form*);

#endif
