/*
 *  Copyright (C) 2003 2004
 *  Stefano Tonetta <stonetta@dit.unitn.it>
 *  Roberto Sebastiani <rseba@dit.unitn.it>
 *
*/
#include "main.h"
#include "automa.h"
#include "form.h"
#include "EWS02.h"
#include "modella.y.tab.h" 




int prom(int x,int i,int D){
  if(i==0){
    if(x<D)
      return 0;
    else
      return D;
  } else
    return x;
}


int val(int* ro,int v,PG* g,int D){
  int i,j;
  int ret;
  if(v<g->V0){
    ret=D+1;
    for(i=0;i<g->sE[v];i++)      
      if(ro[g->E[v][i]]<ret)
	ret=ro[g->E[v][i]];
  } else {
    ret=-1;
    for(i=0;i<g->sE[v];i++)
      if(ro[g->E[v][i]]>ret)
	  ret=ro[g->E[v][i]];
  }
  if(ret<0 || ret>D){
    fprintf(stderr,"Fatal error: val: v=%d\n",v);
    exit(24);
  }
  return prom(ret,g->p[v],D);
}


int incr(int x,int i,int D){
  if(i==1){
    if(x<D)
      return x+1;
    else
      return D;
  } else 
    return x;
}
    



int cnt(int* ro,int v,PG* g,int D){
  int i;
  int ret=0;
  for(i=0;i<g->sE[v];i++)
    if(prom(ro[g->E[v][i]],g->p[g->E[v][i]],D)==val(ro,v,g,D))
      ret++;
  return ret;
}
	

void compute_ends(char* ends,PG* g){
  int new_death=0;
  int i,j;
  for(i=0;i<g->V0+g->V1;i++)
    if(g->sE[i]>0)
      ends[i]=0;
    else {
      ends[i]=1;
      new_death=1;
    }
  while(new_death){
    new_death=0;
    for(i=0;i<g->V0+g->V1;i++)
      if(!ends[i])
	for(j=0;j<g->sE[i];j++)
	  if(ends[g->E[i][j]]){
	    ends[i]=1;
	    new_death=1;
	  }
  }
}

LBA* sim_reduce(LBA* ba){
  
  int b,q1,q2,a,i,j;
  PG* g=(PG*)mymalloc(sizeof(PG));
  int**** id=(int****)mymalloc(2*sizeof(int***));
  int V=0;
  int S=modella_pow2(ba->prop_number);
  
  char* ends;
  
  int *ro,*B,*C;
  char* L;
  int* qL;
  int hqL;
  int tqL;
  int v,w;
  int D;

  LBA* ba2;
  int* idba;
  int* idt;
  char** sim;
  
  form** alpha=(form**)mymalloc(S*sizeof(form*));
  for(a=0;a<S;a++)
    alpha[a]=true;
  for(i=0;i<ba->prop_number;i++){
    form* p=new_form(ATOM,i,NULL,NULL);
    form* n=new_form(NOT,i,NULL,NULL);
    for(a=0;a<S;a++)
      if(modella_pow2(i)&a)
	alpha[a]=simplify(new_form(AND,0,alpha[a],p));
      else 
	alpha[a]=simplify(new_form(AND,0,alpha[a],n));
  } 
  //for(a=0;a<S;a++){
    //print_form_prefix(alpha[a],stdout);
    //printf("\n");
  //}
  for(b=0;b<2;b++){
    id[b]=(int***)mymalloc(ba->states_number*sizeof(int**));
    for(q1=0;q1<ba->states_number;q1++){
      id[b][q1]=(int**)mymalloc(ba->states_number*sizeof(int*));
      for(q2=0;q2<ba->states_number;q2++){
	id[b][q1][q2]=(int*)mymalloc((S+1)*sizeof(int));
	for(a=0;a<S+1;a++)
	  id[b][q1][q2][a]=-1;
      }
    }
  }
  for(i=0;i<ba->trans_number;i++)
    for(a=0;a<S;a++)
      if(idimply(alpha[a],ba->R[i]->label)){
	q1=ba->R[i]->dest;
	for(b=0;b<2;b++)
	  for(q2=0;q2<ba->states_number;q2++)
	    if(id[b][q1][q2][a]==-1)
	      id[b][q1][q2][a]=V++;
      }
  g->V0=V;
  for(q1=0;q1<ba->states_number;q1++)
    for(q2=0;q2<ba->states_number;q2++)
      if(ba->F[q2])
	id[0][q1][q2][S]=V++;
      else
	for(b=0;b<2;b++)
	  id[b][q1][q2][S]=V++;
  g->V1=V-g->V0;
  g->E=(int**)mymalloc(V*sizeof(int*));
  g->sE=(int*)mymalloc(V*sizeof(int));
  g->R=(int**)mymalloc(V*sizeof(int*));
  g->sR=(int*)mymalloc(V*sizeof(int));
  g->p=(char*)mymalloc(V*sizeof(char));
  for(i=0;i<V;i++){
    g->sE[i]=0;
    g->sR[i]=0;
  }
  for(i=0;i<ba->trans_number;i++)
    for(a=0;a<S;a++)
      if(idimply(alpha[a],ba->R[i]->label)){
	for(b=0;b<2;b++)
	  for(q1=0;q1<ba->states_number;q1++){
	    if(id[b][q1][ba->R[i]->source][a]!=-1)
	      g->sE[id[b][q1][ba->R[i]->source][a]]++;
	    if(ba->F[ba->R[i]->dest]){
	      if(id[0][q1][ba->R[i]->dest][S]!=-1)
		g->sR[id[0][q1][ba->R[i]->dest][S]]++;
	    } else {
	      if(id[b][q1][ba->R[i]->dest][S]!=-1)
		g->sR[id[b][q1][ba->R[i]->dest][S]]++;
	    }
	  }
	for(b=0;b<2;b++)
	  for(q2=0;q2<ba->states_number;q2++){
	    if(id[b][ba->R[i]->source][q2][S]!=-1)
	      g->sE[id[b][ba->R[i]->source][q2][S]]++;
	    if(ba->F[ba->R[i]->dest]){
	      if(id[1][ba->R[i]->dest][q2][a]!=-1)
		g->sR[id[1][ba->R[i]->dest][q2][a]]++;
	    } else {
	      if(id[b][ba->R[i]->dest][q2][a]!=-1)
		g->sR[id[b][ba->R[i]->dest][q2][a]]++;
	    }
	  }
      }
  for(i=0;i<V;i++)
    g->E[i]=(int*)mymalloc(g->sE[i]*sizeof(int));
  for(i=0;i<V;i++)
    g->sE[i]=0;
  for(i=0;i<V;i++)
    g->R[i]=(int*)mymalloc(g->sR[i]*sizeof(int));
  for(i=0;i<V;i++)
    g->sR[i]=0;
  for(i=0;i<ba->trans_number;i++)
    for(a=0;a<S;a++)
      if(idimply(alpha[a],ba->R[i]->label)){
	for(b=0;b<2;b++)
	  for(q1=0;q1<ba->states_number;q1++)
	    if(id[b][q1][ba->R[i]->source][a]!=-1)
	      if(ba->F[ba->R[i]->dest]){
		v=id[b][q1][ba->R[i]->source][a];
		w=id[0][q1][ba->R[i]->dest][S];
		g->E[v][g->sE[v]++]=w;
		g->R[w][g->sR[w]++]=v;
	      } else {
		v=id[b][q1][ba->R[i]->source][a];
		w=id[b][q1][ba->R[i]->dest][S];
		g->E[v][g->sE[v]++]=w;
		g->R[w][g->sR[w]++]=v;
	      }
	for(b=0;b<2;b++)
	  for(q2=0;q2<ba->states_number;q2++)
	    if(id[b][ba->R[i]->source][q2][S]!=-1)
	      if(ba->F[ba->R[i]->dest]){
		v=id[b][ba->R[i]->source][q2][S];
		w=id[1][ba->R[i]->dest][q2][a];
		g->E[v][g->sE[v]++]=w;
		g->R[w][g->sR[w]++]=v;
	      } else {
		v=id[b][ba->R[i]->source][q2][S];
		w=id[b][ba->R[i]->dest][q2][a];
		g->E[v][g->sE[v]++]=w;
		g->R[w][g->sR[w]++]=v;
	      }
      }
  
  
  for(b=0;b<2;b++)
    for(q1=0;q1<ba->states_number;q1++)
      for(q2=0;q2<ba->states_number;q2++)
	if(id[b][q1][q2][S]!=-1)
	  g->p[id[b][q1][q2][S]]=b;
  for(i=0;i<g->V0;i++)
    g->p[i]=2;
  //fprintf(stderr,"Vertices:\n");
  //for(b=0;b<2;b++)
    //for(q1=0;q1<ba->states_number;q1++)
      //for(q2=0;q2<ba->states_number;q2++)
	//for(a=0;a<S+1;a++)
	  //if(id[b][q1][q2][a]!=-1)
	    //fprintf(stderr,"b=%d q1=%d q2=%d a=%d id=%d\n",b,q1,q2,a,id[b][q1][q2][a]);
  //fprintf(stderr,"Edges:\n");
  //for(i=0;i<V;i++)
    //for(j=0;j<g->sE[i];j++)
      //fprintf(stderr,"v=%d v'=%d\n",i,g->E[i][j]);
  //fprintf(stderr,"Priority:\n");
  //for(i=0;i<V;i++)
    //fprintf(stderr,"p[%d]=%d\n",i,g->p[i]);
  //for(i=0;i<V;i++){
    //for(j=0;j<g->sE[i];j++)
      //if((i<g->V0 && g->E[i][j]<g->V0) || (i>=g->V0 && g->E[i][j]>=g->V0)){
	//fprintf(stderr,"Fatal error: parity game: (%d,%d) in E\n",i,g->E[i][j]);
	//exit(32);
      //}  
    //for(j=0;j<g->sR[i];j++)
      //if((i<g->V0 && g->R[i][j]<g->V0) || (i>=g->V0 && g->R[i][j]>=g->V0)){
	//fprintf(stderr,"Fatal error: parity game: (%d,%d) in R\n",i,g->R[i][j]);
	//exit(33);
      //}  
  //}
  //for(i=g->V0;i<V;i++)
    //if(g->p[i]!=0 && g->p[i]!=1){
      //fprintf(stderr,"Fatal error: parity game: p[%d]\n",i);
      //exit(23);
    //}  
  
  ends=(char*)mymalloc(V*sizeof(char));
  compute_ends(ends,g);
  //fprintf(stderr,"Ends:\n");
  //for(i=0;i<V;i++)
    //fprintf(stderr,"v=%d ends=%d\n",i,ends[i]);
  
  
  D=0;
  for(i=0;i<V;i++)
    if(!ends[i])
      if(g->p[i]==1)
	D++;
  D++;
  ro=(int*)mymalloc(V*sizeof(int));
  B=(int*)mymalloc(V*sizeof(int));
  C=(int*)mymalloc(V*sizeof(int));  
  for(i=0;i<V;i++)
    if(!ends[i]){
      B[i]=0;
      ro[i]=0;
      C[i]=0;
      for(j=0;j<g->sE[i];j++)
	if(!ends[g->E[i][j]])
	  C[i]++;
    }
  L=(char*)mymalloc(V*sizeof(char));
  qL=(int*)mymalloc(V*sizeof(int));
  hqL=0;
  tqL=0;
  for(i=0;i<V;i++)
    if(!ends[i]){
      if(g->p[i]==1){
	L[i]=1;
	qL[tqL]=i;
	tqL=(tqL+1)%V;
      } else 
	L[i]=0;
    }
  while(hqL!=tqL){
    int t;
    v=qL[hqL];
    hqL=(hqL+1)%V;
    L[v]=0;
    t=ro[v];
    B[v]=val(ro,v,g,D);
    C[v]=cnt(ro,v,g,D);
    ro[v]=incr(B[v],g->p[v],D);
    for(i=0;i<g->sR[v];i++){
      w=g->R[v][i];
      if(!ends[w] && !L[w]){
	if(w<g->V0 && t==B[w] && C[w]>1)
	  C[w]--;
	else if(w<g->V0 && t==B[w] && C[w]==1){
	  L[w]=1;
	  qL[tqL]=w;
	  tqL=(tqL+1)%V;
	} else if(w>=g->V0 && ro[v]==B[w])
	  C[w]++;
	else if(w>=g->V0 && ro[v]>B[w]){
	  L[w]=1;
	  qL[tqL]=w;
	  tqL=(tqL+1)%V;
	}
      }
    }
    
     	
  }
	
  //for(b=0;b<2;b++)
    //for(q1=0;q1<ba->states_number;q1++)
      //for(q2=0;q2<ba->states_number;q2++)
	//if(!ends[id[b][q1][q2][S]])
	  //if(id[b][q1][q2][S]!=-1 && ro[id[b][q1][q2][S]]<D)
	    //if((ba->F[q1] && !ba->F[q2] && b==1)||(!ba->F[q1] && b==0)||(ba->F[q2]&&b==0))
	      //fprintf(stderr,"b=%d q1=%d q2=%d ro=%d\n",b,q1,q2,ro[id[b][q1][q2][S]]);
  ba2=(LBA*)mymalloc(sizeof(LBA));
  ba2->prop_number=ba->prop_number;
  ba2->states_number=0;
  ba2->trans_number=0;
  idba=(int*)mymalloc(ba->states_number*sizeof(int));
  idt=(int*)mymalloc(ba->trans_number*sizeof(int));
  for(i=0;i<ba->states_number;i++)
    idba[i]=-1;
  for(i=0;i<ba->trans_number;i++)
    idt[i]=-1;
  sim=(char**)mymalloc(ba->states_number*sizeof(char*));
  for(i=0;i<ba->states_number;i++){
    sim[i]=(char*)mymalloc(ba->states_number*sizeof(char));
    for(j=0;j<ba->states_number;j++)
      sim[i][j]=0;
  }
  for(b=0;b<2;b++)
    for(q1=0;q1<ba->states_number;q1++)
      for(q2=0;q2<ba->states_number;q2++)
	if(id[b][q1][q2][S]!=-1 && !ends[id[b][q1][q2][S]])
	  if(ro[id[b][q1][q2][S]]<D)
	    if((ba->F[q1] && !ba->F[q2] && b==1)||(!ba->F[q1] && b==0)||(ba->F[q2]&&b==0))
	      sim[q1][q2]=1;
  for(i=0;i<ba->states_number;i++){
    if(idba[i]==-1){
      idba[i]=ba2->states_number;
      ba2->states_number++;
    }
    for(j=i+1;j<ba->states_number;j++)
      if(sim[i][j] && sim[j][i])
	idba[j]=idba[i];
  }
  for(i=0;i<ba->trans_number;i++){
    if(idt[i]==-1){
      idt[i]=ba2->trans_number;
      ba2->trans_number++;
    }
    for(j=i+1;j<ba->trans_number;j++)
      if(idba[ba->R[i]->source]==idba[ba->R[j]->source] && idba[ba->R[i]->dest]==idba[ba->R[j]->dest])
	idt[j]=idt[i];
  }
  ba2->R=(transition**)mymalloc(ba2->trans_number*sizeof(transition*));
  for(i=0;i<ba2->trans_number;i++){
    int first=1;
    ba2->R[i]=(transition*)mymalloc(ba2->trans_number*sizeof(transition));
    for(j=i;j<ba->trans_number;j++)
      if(idt[j]==i){
	if(first){
	  first=0;
	  ba2->R[i]->source=idba[ba->R[j]->source];
	  ba2->R[i]->dest=idba[ba->R[j]->dest];
	  ba2->R[i]->label=ba->R[j]->label;
	} else 
	  ba2->R[i]->label=simplify(new_form(OR,0,ba2->R[i]->label,ba->R[j]->label));
      }
  }
  ba2->F=(char*)mymalloc(ba2->states_number*sizeof(char));
  for(i=0;i<ba2->states_number;i++){
    ba2->F[i]=0;
    for(j=i;j<ba->states_number && !ba2->F[i];j++)
      if(idba[j]==i && ba->F[j])
	ba2->F[i]=1;
  }    
  return ba2;
}
