/*
 *  Copyright (C) 2003 2004
 *  Stefano Tonetta <stonetta@dit.unitn.it>
 *  Roberto Sebastiani <rseba@dit.unitn.it>
 *
*/
#include "main.h"
#include "automa.h"
#include "GL02.h"
#include "form.h"
#include "cover.h"
#include "struct.h"


void TLGBAtodot(TLGBA* b){ 
  int i,j,k;
  FILE* dotfile;
  dotfile=fopen("automa.dot","w");
  if(dotfile!=NULL){
    fprintf(dotfile,"digraph modella {\n");
    fprintf(dotfile,"init -> n0;\n");
    for(i=0;i<b->trans_number;i++){
      fprintf(dotfile,"n%d -> n%d [label=\"",b->R[i]->source,b->R[i]->dest);
	  print_form_prefix(b->R[i]->label,dotfile);
	  for(k=0;k<b->fair_number;k++)
	    if(b->F[k][i])
	      fprintf(dotfile," (%d)",k);
	  fprintf(dotfile,"\"];\n");
    }
    fprintf(dotfile,"init [shape=plaintext,label=\"\"];\n");
    for(i=0;i<b->states_number;i++)
      fprintf(dotfile,"n%d [shape=point,label=\"\"];\n",i);
    fputs("}\n",dotfile);
    fclose(dotfile);
    if (!system("dot -Tps automa.dot -o automa.ps"))
      system("ghostview automa.ps");
    else yyerror("Impossibile generare il file .ps");
  } else yyerror("Impossibile aprire il file");
  
}


void print_TLGBA2(TLGBA* b){
  int i,j,k;
  printf("%d\n",b->states_number);
  printf("%d\n",b->trans_number);
  printf("%d\n",b->prop_number);
  for(i=0;i<b->trans_number;i++){
    print_form_prefix(b->R[i]->label,stdout);
    printf("%d %d ",b->R[i]->source,b->R[i]->dest);
    for(k=0;k<b->fair_number;k++){
      if(b->F[k][i])
	printf("(%d) ",k);
    }
    printf("\n");
  }
  
}


TLGBA* GBAtoTLGBA(GBA* b1){
  int i,j,k;
  int states_number=1;
  int trans_number=b1->initial_states;
  TLGBA* b2=(TLGBA*)mymalloc(sizeof(TLGBA));
  char* id=(char*)mymalloc(b1->states_number*sizeof(char));
  for(i=0;i<b1->states_number;i++){
    id[i]=0;
    for(j=0;j<i && id[i]==0;j++)
      if(idcmp(b1->Q[j]->s->right->left->id,b1->Q[i]->s->right->left->id))
	id[i]=id[j];
    if(id[i]==0){
      id[i]=states_number;
      states_number++;
    }
  }
  for(i=0;i<b1->states_number;i++)
    for(j=0;j<b1->states_number;j++)
      if(b1->R[i][j])
	trans_number++;
  b2->states_number=states_number;
  b2->trans_number=trans_number;
  b2->prop_number=b1->prop_number;
  b2->R=(transition**)mymalloc(b2->trans_number*sizeof(transition*));
  for(i=0;i<b2->trans_number;i++)
    b2->R[i]=(transition*)mymalloc(sizeof(transition));
  b2->fair_number=b1->fair_number;
  b2->F=(char**)mymalloc(b2->fair_number*sizeof(char*));
  for(i=0;i<b2->fair_number;i++){
    b2->F[i]=(char*)mymalloc(b2->trans_number*sizeof(char));
  }
  trans_number=0;
  for(i=0;i<b1->initial_states;i++){
    b2->R[trans_number]->source=0;
    b2->R[trans_number]->dest=id[i];
    b2->R[trans_number]->label=b1->Q[i]->s->left;
    for(k=0;k<b1->fair_number;k++)
      b2->F[k][trans_number]=b1->F[k][j];
    trans_number++;
  }
  for(i=0;i<b1->states_number;i++)
    for(j=0;j<b1->states_number;j++)
      if(b1->R[i][j]){
	for(k=0;k<trans_number && (b2->R[k]->source!=id[i] || b2->R[k]->dest!=id[j] || b2->R[k]->label!=b1->Q[j]->s->left);k++);
	if(k==trans_number){	  
	  b2->R[trans_number]->source=id[i];
	  b2->R[trans_number]->dest=id[j];
	  b2->R[trans_number]->label=b1->Q[j]->s->left;
	  for(k=0;k<b1->fair_number;k++)
	    b2->F[k][trans_number]=b1->F[k][j];
	  trans_number++;
	}
      }
  b2->trans_number=trans_number;
  if(verbosity>1)
    print_TLGBA2(b2);
  return b2;
}







LBA* TLGBAtoLBA(TLGBA* b1){
  int i,j;
  if(b1->fair_number==0){
    LBA* b2=(LBA*)mymalloc(sizeof(LBA));
    b2->states_number=b1->states_number;
    b2->prop_number=b1->prop_number;
    b2->trans_number=b1->trans_number;
    b2->R=b1->R;
    b2->F=(char*)mymalloc(b2->states_number*sizeof(char));
    for(i=0;i<b2->states_number;i++)
      b2->F[i]=1;
    return b2;
  } else {
    LBA* b2=(LBA*)mymalloc(sizeof(LBA));
    b2->states_number=b1->states_number*(b1->fair_number+1);
    b2->trans_number=b1->trans_number*(b1->fair_number+1);
    b2->prop_number=b1->prop_number;
    b2->R=(transition**)mymalloc(b2->trans_number*sizeof(transition*));
    for(i=0;i<b2->trans_number;i++)
      b2->R[i]=(transition*)mymalloc(sizeof(transition));
    b2->F=(char*)mymalloc(b2->states_number*sizeof(char));
    for(i=0;i<b2->trans_number;i++)
      if(i/b1->trans_number<b1->fair_number && b1->F[i/b1->trans_number][i%b1->trans_number]){
	b2->R[i]->source=b1->R[i%b1->trans_number]->source+i/b1->trans_number*b1->states_number;
	b2->R[i]->dest=b1->R[i%b1->trans_number]->dest+(i/b1->trans_number+1)*b1->states_number;
	b2->R[i]->label=b1->R[i%b1->trans_number]->label;
      } else if(i/b1->trans_number<b1->fair_number){
	b2->R[i]->source=b1->R[i%b1->trans_number]->source+i/b1->trans_number*b1->states_number;
	b2->R[i]->dest=b1->R[i%b1->trans_number]->dest+i/b1->trans_number*b1->states_number;
	b2->R[i]->label=b1->R[i%b1->trans_number]->label;
      } else {
	b2->R[i]->source=b1->R[i%b1->trans_number]->source+i/b1->trans_number*b1->states_number;
	b2->R[i]->dest=b1->R[i%b1->trans_number]->dest;
	b2->R[i]->label=b1->R[i%b1->trans_number]->label;
      }
    for(i=0;i<b2->states_number;i++)
      if(i/b1->states_number==b1->fair_number)
	b2->F[i]=1;
      else
	b2->F[i]=0;
    return b2;
  }
}

