%{
/*
 *  Copyright (C) 2003 2004
 *  Stefano Tonetta <stonetta@dit.unitn.it>
 *  Roberto Sebastiani <rseba@dit.unitn.it>
 *
*/

#include "main.h"
#include "modella.y.tab.h" 

  int yyerror(char *s);
  

%}

%s FORM

%%
<INITIAL>. {
  unput(*yytext);
  BEGIN FORM;
  if(syntax==spin)
    return SPIN;
  else if(syntax==nusmv)
    return NUSMV;
  else
    return LBTT;
}
<FORM>[ \n\t]                 ;
<FORM>"&"                     return(AND);
<FORM>"|"                     return(OR);
<FORM>"!"                     return(NOT);
<FORM>"F"                     return(FUTURE);
<FORM>"G"                     return(GLOBALLY);
<FORM>"U"                     return(UNTIL);
<FORM>"V"                     return(RELEASE);
<FORM>"X"                     return(NEXT);
<FORM>"t"                     return(TRUE);
<FORM>"f"                     return(FALSE);
<FORM>"&&"                    return(AND);
<FORM>"||"                    return(OR);
<FORM>"<>"                    return(FUTURE);
<FORM>"[]"                    return(GLOBALLY);
<FORM>"->"                    return(IMPLY);
<FORM>"<->"                   return(EQUIV);
<FORM>"true"                  return(TRUE);
<FORM>"false"                 return(FALSE);
<FORM>"("                     return('(');
<FORM>")"                     return(')');
<FORM>"TRUE"                  return(TRUE);
<FORM>"FALSE"                 return(FALSE);
<FORM>"="                     return *yytext;
<FORM>"<"                     return *yytext;
<FORM>">"                     return *yytext;
<FORM>"+"                     return *yytext;
<FORM>"-"                     return *yytext;
<FORM>"*"                     return *yytext;
<FORM>"/"                     return *yytext;
<FORM>"{"                     return *yytext;
<FORM>"}"                     return *yytext;
<FORM>","                     return *yytext;
<FORM>"xor"                   return XOR;
<FORM>"!="                    return NE;
<FORM>"<="                    return LE;
<FORM>">="                    return GE;
<FORM>"mod"                   return MOD;
<FORM>"in"                    return IN;
<FORM>"union"                 return UNION;
<FORM>[a-zA-Z0-9][A-Za-z0-9_\[\].\$#-]* { 
               yylval.prop = (char*)mymalloc((strlen(yytext)+1)*sizeof(char));
               strcpy(yylval.prop,yytext);
	       return(ATOM);
                        }
<FORM>.                       {
                             yyerror("illegal token"); 
                        }
%%

int yywrap(void) { 
	return 1; 
}

int yyerror(char *s) {
  fprintf(stderr,"modella: %s: %s\n",s,yytext);
  return 0; 
}
