/**CHeaderFile*****************************************************************

  FileName    [tree.h]

  Package     [tree]

  Author      [Stefano Tonetta]

  Copyright   [This file is part of MoDeLLa.
  Copyright (C) 2003-2006 by Stefano Tonetta and Roberto Sebastiani.]

  Version     [1.5.9]

******************************************************************************/

#ifndef TREE_H
#define TREE_H

#include <stdio.h>
#include "form.h"

/*---------------------------------------------------------------------------*/
/* Type declarations                                                         */
/*---------------------------------------------------------------------------*/
typedef struct tree{
  int type;
  int prop;
  char *name;
  struct tree* left;
  struct tree* right;
} tree;


/*---------------------------------------------------------------------------*/
/* Functions prototypes                                                      */
/*---------------------------------------------------------------------------*/
tree* new_tree(int,char*,tree*,tree*);
tree* dup_tree(tree*);
void delete_tree(tree*);
int treecmp(tree*,tree*);
form* tree2form(tree*);
tree* NNF(tree*);
tree* semplifytree(tree*, int);
tree* dual(tree*);
void print_tree_prefix(tree*,FILE*);
void print_tree_spin(tree*,FILE*);
void print_tree_nusmv(tree*,FILE*);
int print_tree_wring(tree*,FILE*);


#endif
